;**********************************************************************
;    Filename:      osc.asm                                           *
;    Date:          2003/1/3                                         *
;    File Version:                                                    *
;**********************************************************************
 
         list      p=16F84             ; list directive to define processor
         #include <p16F84.inc>         ; processor specific variable definitions
         LIST
; P16F84.INC  Standard Header File, Version 2.00    Microchip Technology, Inc.
         LIST
  
         __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
 
;***** VARIABLE DEFINITIONS
w_temp        EQU     0x0C        ; variable used for context saving 
status_temp   EQU     0x0D        ; variable used for context saving
 
wait_data       EQU     0x15            ;wait data ram
wave_count	EQU	0x16		;wave counter
taihi		EQU	0x17		;taihi data
henka_step	EQU	0x18		;henka step data
time_count	EQU	0x19		;time change
dummy		EQU	0x1a		;kukei dummy
 

;**********************************************************************
                ORG     0x000             ; processor reset vector
                goto    main              ; go to beginning of program
 
                ORG     0x004             ; interrupt vector location
                movwf   w_temp            ; save off current W register contents
                movf    STATUS,w          ; move status register into W register
                movwf   status_temp       ; save off contents of STATUS register
                ;---------------------------------------------------------------

int_end
                movf    status_temp,w     ; retrieve copy of STATUS register
                movwf   STATUS            ; restore pre-isr STATUS register contents
                swapf   w_temp,f
                swapf   w_temp,w          ; restore pre-isr W register contents
                retfie                    ; return from interrupt
;--------------------------------------------------------------------------
main
                call    port_set
                movlw   00h
                movwf   PORTB
		bcf	PORTA,1
 
		call	timer0_set

		movlw	00h
		movwf	wave_count
		movlw	01h
		movwf	henka_step
		movlw	00h
		movwf	dummy
		movlw	00h
		movwf	time_count
		;---------------------------
		btfss	PORTA,2
		goto	main_loop_sin
		btfss	PORTA,3
		goto	main_loop_nok
		btfss	PORTA,4
		goto	main_loop_ha2
		;---------------------------
main_loop_ku
		bcf	PORTA,1
main_loop_ku2
		clrw
		btfsc	wave_count,7
		comf	dummy,0
		movwf	PORTB
		movf	henka_step,0
		addwf	wave_count,1
		btfsc	STATUS,0
		clrf	wave_count
		btfsc	PORTA,0
		goto	main_loop_ku2
		call	time_change
		goto	main_loop_ku2
		;---------------------------
main_loop_sin
		bsf	PORTA,1
main_loop_sin2
		call	wave_form_sin
		movwf	PORTB
		movf	henka_step,0
		addwf	wave_count,1
		btfsc	STATUS,0
		clrf	wave_count
		btfsc	PORTA,0
		goto	main_loop_sin2
		call	time_change
		goto	main_loop_sin2
		;---------------------------
main_loop_nok
		bsf	PORTA,1
main_loop_nok2
		movf	wave_count,0
		movwf	PORTB
		movf	henka_step,0
		addwf	wave_count,1
		btfsc	STATUS,0
		clrf	wave_count
		btfsc	PORTA,0
		goto	main_loop_nok2
		call	time_change
		goto	main_loop_nok2
		;---------------------------
main_loop_ha2
		bcf	PORTA,1
main_loop_ha21
		movf	wave_count,0
		btfsc	STATUS,2
		goto	main_loop_ha22
		clrw
		goto	main_loop_ha23
main_loop_ha22
		comf	dummy,0
main_loop_ha23
		movwf	PORTB
		movf	henka_step,0
		addwf	wave_count,1
		btfsc	STATUS,0
		clrf	wave_count
		btfsc	PORTA,0
		goto	main_loop_ha21
		call	time_change
		goto	main_loop_ha21
;-------------------------------------------------------------------------------
time_change
		call	wait_1
		call	wait_1
		btfsc	PORTA,0
		return
		incf	time_count,1
		movf	time_count,0
		sublw	1bh
		btfsc	STATUS,2
		goto	time_change2
time_change3
		btfss	PORTA,0
		goto	time_change3
		call	wait_1
		call	wait_1
		btfss	PORTA,0
		goto	time_change3
		call	time_change_sub
		movwf	henka_step
		return
time_change2
		movlw	00h
		movwf	time_count
		goto	time_change3
;--------------------------------------------------------------------------------
time_change_sub
		movf    time_count,0
                movwf   taihi
                movlw   low(time_table)
                addwf   taihi,1
                movlw   high(time_table)
                movwf   PCLATH
                addcf   PCLATH,1
                movf    taihi,0
                movwf   PCL
time_table   
                retlw   01h
		retlw	02h
		retlw	03h
		retlw	04h
		retlw	05h
		retlw	06h
		retlw	07h
		retlw	08h
		retlw	09h
		retlw	0ah
		retlw	0bh
		retlw	0ch
		retlw	0dh
		retlw	0eh
		retlw	0fh
		retlw	10h
		retlw	12h
		retlw	13h
		retlw	14h
		retlw	16h
		retlw	18h
		retlw	1ah
		retlw	1dh
		retlw	20h
		retlw	25h
		retlw	2bh
		retlw	34h

;-------------------------------------------------------------------------------
wait_1          
                movlw   0ffh
                movwf   wait_data
wait_2
                nop
                decfsz  wait_data,1
                goto    wait_2
                return
;--------------------------------------------------------------------------------
wave_form_sin   movf    wave_count,0
                movwf   taihi
                movlw   low(sin_table)
                addwf   taihi,1
                movlw   high(sin_table)
                movwf   PCLATH
                addcf   PCLATH,1
                movf    taihi,0
                movwf   PCL
sin_table   
                retlw   7Fh
		retlw	82h
		retlw	85h
		retlw	88h
		retlw	8Bh
		retlw	8Fh
		retlw	92h
		retlw	95h
		retlw	98h
		retlw	9Bh
		retlw	9Eh
		retlw	0A1h
		retlw	0A4h
		retlw	0A7h
		retlw	0AAh
		retlw	0ADh
		retlw	0B0h
		retlw	0B3h
		retlw	0B6h
		retlw	0B8h
		retlw	0BBh
		retlw	0BEh
		retlw	0C1h
		retlw	0C3h
		retlw	0C6h
		retlw	0C8h
		retlw	0CBh
		retlw	0CDh
		retlw	0D0h
		retlw	0D2h
		retlw	0D5h
		retlw	0D7h
		retlw	0D9h
		retlw	0DBh
		retlw	0DDh
		retlw	0E0h
		retlw	0E2h
		retlw	0E4h
		retlw	0E5h
		retlw	0E7h
		retlw	0E9h
		retlw	0EBh
		retlw	0ECh
		retlw	0EEh
		retlw	0EFh
		retlw	0F1h
		retlw	0F2h
		retlw	0F4h
		retlw	0F5h
		retlw	0F6h
		retlw	0F7h
		retlw	0F8h
		retlw	0F9h
		retlw	0FAh
		retlw	0FBh
		retlw	0FBh
		retlw	0FCh
		retlw	0FDh
		retlw	0FDh
		retlw	0FEh
		retlw	0FEh
		retlw	0FEh
		retlw	0FEh
		retlw	0FEh
		retlw	0FFh
		retlw	0FEh
		retlw	0FEh
		retlw	0FEh
		retlw	0FEh
		retlw	0FEh
		retlw	0FDh
		retlw	0FDh
		retlw	0FCh
		retlw	0FBh
		retlw	0FBh
		retlw	0FAh
		retlw	0F9h
		retlw	0F8h
		retlw	0F7h
		retlw	0F6h
		retlw	0F5h
		retlw	0F4h
		retlw	0F2h
		retlw	0F1h
		retlw	0EFh
		retlw	0EEh
		retlw	0ECh
		retlw	0EBh
		retlw	0E9h
		retlw	0E7h
		retlw	0E5h
		retlw	0E4h
		retlw	0E2h
		retlw	0E0h
		retlw	0DDh
		retlw	0DBh
		retlw	0D9h
		retlw	0D7h
		retlw	0D5h
		retlw	0D2h
		retlw	0D0h
		retlw	0CDh
		retlw	0CBh
		retlw	0C8h
		retlw	0C6h
		retlw	0C3h
		retlw	0C1h
		retlw	0BEh
		retlw	0BBh
		retlw	0B8h
		retlw	0B6h
		retlw	0B3h
		retlw	0B0h
		retlw	0ADh
		retlw	0AAh
		retlw	0A7h
		retlw	0A4h
		retlw	0A1h
		retlw	9Eh
		retlw	9Bh
		retlw	98h
		retlw	95h
		retlw	92h
		retlw	8Fh
		retlw	8Bh
		retlw	88h
		retlw	85h
		retlw	82h
		retlw	7Fh
		retlw	7Ch
		retlw	79h
		retlw	76h
		retlw	73h
		retlw	6Fh
		retlw	6Ch
		retlw	69h
		retlw	66h
		retlw	63h
		retlw	60h
		retlw	5Dh
		retlw	5Ah
		retlw	57h
		retlw	54h
		retlw	51h
		retlw	4Eh
		retlw	4Bh
		retlw	48h
		retlw	46h
		retlw	43h
		retlw	40h
		retlw	3Dh
		retlw	3Bh
		retlw	38h
		retlw	36h
		retlw	33h
		retlw	31h
		retlw	2Eh
		retlw	2Ch
		retlw	29h
		retlw	27h
		retlw	25h
		retlw	23h
		retlw	21h
		retlw	1Eh
		retlw	1Ch
		retlw	1Ah
		retlw	19h
		retlw	17h
		retlw	15h
		retlw	13h
		retlw	12h
		retlw	10h
		retlw	0Fh
		retlw	0Dh
		retlw	0Ch
		retlw	0Ah
		retlw	09h
		retlw	08h
		retlw	07h
		retlw	06h
		retlw	05h
		retlw	04h
		retlw	03h
		retlw	03h
		retlw	02h
		retlw	01h
		retlw	01h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	00h
		retlw	01h
		retlw	01h
		retlw	02h
		retlw	03h
		retlw	03h
		retlw	04h
		retlw	05h
		retlw	06h
		retlw	07h
		retlw	08h
		retlw	09h
		retlw	0Ah
		retlw	0Ch
		retlw	0Dh
		retlw	0Fh
		retlw	10h
		retlw	12h
		retlw	13h
		retlw	15h
		retlw	17h
		retlw	19h
		retlw	1Ah
		retlw	1Ch
		retlw	1Eh
		retlw	21h
		retlw	23h
		retlw	25h
		retlw	27h
		retlw	29h
		retlw	2Ch
		retlw	2Eh
		retlw	31h
		retlw	33h
		retlw	36h
		retlw	38h
		retlw	3Bh
		retlw	3Dh
		retlw	40h
		retlw	43h
		retlw	46h
		retlw	48h
		retlw	4Bh
		retlw	4Eh
		retlw	51h
		retlw	54h
		retlw	57h
		retlw	5Ah
		retlw	5Dh
		retlw	60h
		retlw	63h
		retlw	66h
		retlw	69h
		retlw	6Ch
		retlw	6Fh
		retlw	73h
		retlw	76h
		retlw	79h
		retlw	7Ch
;-------------------------------------------------------------------------------



;-------------------------------------------------------------------------------
port_set                                ;RA0,RA2,RA3,RA4(IN)
					;RA1(OUT)
                                        ;RB0,RB1,RB2,RB3,RB4,RB5,RB6,RB7(OUT)
                bsf     STATUS,RP0
		movlw	1dh
		movwf	TRISA
		clrf	TRISB
                bcf     STATUS,RP0
                return
;-------------------------------------------------------------------------------- 
timer0_set
                bsf     STATUS,RP0
                movlw   083h            ;(1)PORTB NOT PULLUP
                                        ;(0)INTEDG
                                        ;(0)TOCS
                                        ;(0)TOSE
                                        ;(0)PSA
                                        ;(011)1/16
                movwf   OPTION_REG
                bcf     STATUS,RP0
                return
;-------------------------------------------------------------------------------- 
                END                     ; directive 'end of program'
